<template>
  <div>
    <!--<div class="md-layout-item md-medium-size-100 md-xsmall-size-100 md-size-100">-->
      <!--<md-card class="md-card-plain">-->
        <!--<md-card-content style="text-align: right">-->
          <!--<md-button class="md-button-primary" @click="exportData">-->
            <!--Export-->
            <!--<vue-loading v-if="isExporting" type="spin" color="#ffffff" :size="{ width: '18px', height: '18px' }"></vue-loading>-->
          <!--</md-button>-->
        <!--</md-card-content>-->
      <!--</md-card>-->
    <!--</div>-->
    <data-table ref="datatable" :get-data="getDistributionHetaTokens">
      <template slot="table-toolbar">
        <div class="md-toolbar-section-start">
          <h1 class="md-title">Users</h1>
        </div>

        <md-field md-clearable class="md-field-search md-toolbar-section-end">
          <md-input placeholder="Search by user..." v-model="search" @input="searchUsers"/>
        </md-field>
      </template>

      <md-table-head class="col1">#</md-table-head>
      <md-table-head class="col2" data-sort-field="email">User</md-table-head>
      <md-table-head class="col3" data-sort-field="available_balance">Buy Amount</md-table-head>
      <md-table-head class="col4" data-sort-field="bounty_amount">Bounty Amount</md-table-head>
      <md-table-head class="col5">Withdraw Amount</md-table-head>
      <md-table-head class="col6">Action</md-table-head>

      <template slot="body" slot-scope="{ item, index }">
        <md-table-row >
          <md-table-cell class="col1"> {{ index + 1 }}</md-table-cell>
          <md-table-cell class="col2">{{ item.email }}</md-table-cell>
          <md-table-cell class="col3">{{ item.available_balance | formatCurrencyAmount('heta', 0)}}</md-table-cell>
          <md-table-cell class="col4">{{ item.bounty_amount | formatCurrencyAmount('heta', 0) }}</md-table-cell>
          <md-table-cell class="col5">{{ item.withdraw_amount | formatCurrencyAmount('heta', 0) }}</md-table-cell>
          <md-table-cell class="col6">
            <div v-if="canApproveBounty(item)">
              <md-button class="md-raised md-button-primary"
                         @click="showConfirmApproveDialog(item)">Approve Bounty</md-button>
            </div>
          </md-table-cell>
        </md-table-row>
      </template>
    </data-table>

    <md-dialog-confirm
      :md-active.sync="isShowConfirmApproveDialog"
      md-title="Are you sure you want to approve?"
      md-confirm-text="Agree"
      md-cancel-text="Disagree"
      @md-cancel="onCancelApprove"
      @md-confirm="onConfirmApprove"/>
  </div>
</template>

<script>
  import rf from '../../common/requests/RequestFactory';
  import bignumber from 'bignumber.js';
  import { VueLoading } from 'vue-loading-template';

  export default {
    components: {
      VueLoading
    },
    data () {
      return {
        search: '',
        itemWillApprove: {},
        isShowConfirmApproveDialog: false,
        isExporting: false,
      }
    },
    methods: {
      getTimzoneOffset() {
        let d = new Date();
        return d.getTimezoneOffset();
      },

      // exportData() {
      //   // this.isExporting = true;
      //   window.location.href = `${this.$baseUrl}/export/distribution-hetatokens?timezone_offset=${this.getTimzoneOffset()}`;
      // },

      canApproveBounty(item) {
        return parseInt(item.kyc_status) !== 2 && bignumber(item.bounty_amount).gt(0) && !item.approve_status;
      },

      showConfirmApproveDialog (item) {
        this.isShowConfirmApproveDialog = true;
        this.itemWillApprove = item;
      },

      onConfirmApprove () {
        this.approveBountyWithdraw(this.itemWillApprove);
        this.$toasted.show('You approved successfully!', {
          theme: 'bubble',
          position: 'top-right',
          duration: 2000
        });
      },

      onCancelApprove () {
        this.itemWillApprove = {};
      },

      refreshDataTable () {
        this.$refs.datatable.refresh();
      },

      searchUsers: _.debounce(function() {
        this.refreshDataTable();
      }, 500),

      getDistributionHetaTokens (params) {
        const meta = {
          search: this.search
        };
        return rf.getRequest('WalletRequest').getDistributionHetaTokens(Object.assign({}, params, meta));
      },

      approveBountyWithdraw (item) {
        rf.getRequest('WalletRequest').approveBountyWithdraw(item).then(res => {
          this.itemWillApprove = {};
          this.refreshDataTable();
        });
      },
    },
  }
</script>

<style lang="scss">
  .product__paginate {
    li {
      display: inline-block;
    }
  }

  .pagination-prev,
  .pagination-next {
    position: relative;

    a {
      position: relative;
      z-index: 1;
    }
  }

  .pagination-prev:before,
  .pagination-next:before {
    content: '';
    display: block;
    width: 10px;
    height: 10px;
    background-image: url('/images/prev.png');
    background-size: cover;
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);
  }

  .pagination-next:before {
    background-image: url('/images/next.png');
  }
</style>

<style lang="scss" scoped>
  .md-field-filter-status {
    margin-right: 15px;
    max-width: 300px;
  }

  .md-field-search {
    max-width: 400px;
  }

  .md-card .md-card-content {
    padding: 0px 20px;
  }

  .md-card {
    margin: 0px;
  }

  .col1 {
    width: 100px;
    max-width: 100px;
    word-wrap: break-word;
  }

  .col2 {
    width: 300px;
    max-width: 300px;
    word-wrap: break-word;
  }

  .col3 {
    width: 300px;
    max-width: 300px;
    word-wrap: break-word;
  }

  .col4 {
    width: 250px;
    max-width: 250px;
    word-wrap: break-word;
  }

  .col5 {
    width: 200px;
    max-width: 200px;
    &.pending {
      color: #8a6d3b;
      font-weight: 700;
    }
    &.approved {
      color: #3c763d;
      font-weight: 700;
    }
    &.rejected {
      color: #a94442;
      font-weight: 700;
    }
  }

  .col6 {
    width: 300px;
    max-width: 300px;
  }
</style>
